***************************************************************************************
*(C)                                                                         
*  35, . 355                                                                 
* ()  . .                                                                        
***************************************************************************************
* Program Name 
* memloader.asm
***************************************************************************************
* Program Intent
*        I/O  
*  SCI     
***************************************************************************************
* Program Description                                                                                                                                                                                   
*  :                                          
* -   200h,   BIO=0
* -   
* -  XINT2   CNF
* -  XINT3     (  SCI)
* -    SCI    :
*    (  SCI )
*     
*   
*   
*   
*   
*   ,      
*        
***************************************************************************************
* Program Notes
*   reset - 0000h
***************************************************************************************
* Program Results
*    
*   200h,   BIO=0
*   0FEh,          8  16
***************************************************************************************
* version 1.00
* 11.03.15
* review 11.03.15                                                                  
***************************************************************************************
			.include "C240APP.h"
	;  Reset,  
			.sect "vectors"
RSVECT 		B _c_int0
            
			.text
			.global _c_int0
_c_int0
		    ;  BIO,  BIO=0,    200h
		    bcnd 200h, BIO 
		;Disable watchdog (Vccp=5v), watchdog counter reset p6-12
			LDP #00E0h
			SPLK #0006Fh, WD_CNTL
			SPLK #05555h, WD_KEY
			SPLK #0AAAAh, WD_KEY
******************************************************************
*   XINTx/IO
******************************************************************
			BIT XINT2_CNTL, BIT6
			bcnd nocnf, NTC
			SETC CNF
nocnf   	BIT XINT3_CNTL, BIT6	
		    bcnd SCILoad, NTC ;  XINT3=0,   SCI
******************************************************************  			
           ;   IN
            ldp #0h
            splk #0AF7Fh, 60h ;   in
            splk #8000h, 61h ;  PA
            splk #7980h, 62h ;  b
            splk next, 63h ;  
            splk #8B00h, 64h
            splk #8B00h, 65h
            splk #8B00h, 66h
            lar AR0, #60h
            mar *, AR0
            lacc #11B0h ;    
            rpt #6
            tblw *+
            
           splk #4000h, 7Eh ;     I/O!
        ;    
           call rio ;   
           sub #8
           bcnd mem8, EQ ;     8- 
           sub #8
           bcnd mem16, EQ ;     16- 
           b end
******************************************************************
*    16- 
******************************************************************           
mem16      call rio ;     
load16     call rio
           bcnd end16, EQ ;  ,   0000
******************************************************************
*    16-    
******************************************************************           
           lar AR5, 7Fh ;  
           mar *, AR5
           sbrk #1 ;     banz
           call rio ;  
           sacl 7Dh ;   
           call rio ;  
           bcnd l16pr, EQ  ;  0,   
***     ***                                  
           lar AR4, 7Dh ;  
           mar *, AR4
l16d	   call rio
		   sacl *+, AR5 ;    ..
		   banz l16d, AR4		           
           b load16 ;  ..
***     ***                       
l16pr      call rio
           lacl 7Dh ;  
           tblw 7Fh ;  
           add #1 ;   
           sacl 7Dh ;   
           banz l16pr
******************************************************************           
           b load16  ;  ..
end16
           ;     
		   splk #4001h, 7Eh ;    
           call rio  
           bacc

******************************************************************
*    8- 
******************************************************************                      
mem8       
		   call getword ;     
load8	   call getword
		   bcnd end8, EQ ;  ,  0000	
******************************************************************
*    8-    
******************************************************************           
           lar AR5, 7Fh ;  
		   mar *, AR5	
           sbrk #1 ;     banz
           call getword ;  
           sacl 7Dh ;   
           call getword ;   
           bcnd l8p, EQ  ;  0,   
***     ***
           lar AR4, 7Dh ;  
           mar *, AR4
l8d	       call getword
		   sacl *+, AR5 ;    
		   banz l8d, AR4		           
           b load8	;  ..   	           
***     ***
l8p        call getword
           lacl 7Dh ;  
           tblw 7Fh ;  
           add #1 ;   
           sacl 7Dh ;   
           banz l8p 
******************************************************************           
           b load8  ;  ..
           ;    
end8       splk #4001h, 7Eh 
		   call getword ; 
		   bacc

******************************************************************  			
*    SCI		   
******************************************************************  			
SCILoad
		;  SCI
          SPLK #0017h, SCI_CCNTL ; 1 stop bit,no parity,8 char bits,
							 ; async mode, idleline protocol
		  SPLK #0013h, SCI_CNTL1 ; Enable TX, RX, internal SCICLK
		  SPLK #0000h, SCI_HBAUD
		  SPLK #0040h, SCI_LBAUD ; Baud Rate=19200 b/s 10 MHz SYSCLK)
  		  SPLK #0022h, SCI_PORT_C2 ; Enable TXD & RXD pins
		  SPLK #0033h, SCI_CNTL1 ; Relinquish SCI from Reset.
          
		  call getSCIword ;     
          sacl 7Dh
loadSCI	  call getSCIword
		  bcnd endSCI, EQ ;  ,  0000
******************************************************************
*    SCI  
******************************************************************		  
          sacl 7Fh
          lar AR5, 7Fh ;  
		  mar *, AR5
          sbrk #1 ;    banz
          call getSCIword ;  
          sacl 7Eh ;   
		  call getSCIword ;   
          bcnd lSCIpr1, EQ ;  0,    
***     ***
          lar AR4, 7Eh ;  
          mar *, AR4
lSCId	  call getSCIword
		  sacl *+, AR5
		  banz lSCId, AR4		           
          b loadSCI		                      
          
***     ***          
lSCIpr1   lacl 7Eh ;   
lSCIpr    sacl 7Eh ;   
		  call getSCIword
          sacl 7Fh
          lacl 7Eh ;  
          tblw 7Fh
          add #1 ;   
          banz lSCIpr
******************************************************************
		  b loadSCI			            
endSCI
          ;    -  
          lacc #0AAh
          ldp #0E0h
          sacl SCI_TX_BUF
          ;     		      
          ldp #0
          lacl 7Dh
          bacc
          nop
		  nop
		  nop

******************************************************************  					   	
end		  b $
			nop
			nop
			nop

******************************************************************
*    SCI  
* (   16     )
******************************************************************
getSCIword
			LDP #00E0h
WH			BIT	SCI_RX_STAT, BIT6	; Test RXRDY bit
		 	BCND	WH, NTC
		  	LACC	SCI_RX_BUF, 8 ;   - 	
WL			BIT	SCI_RX_STAT, BIT6	; Test RXRDY bit
		 	BCND	WL, NTC
		  	OR		SCI_RX_BUF ;   - 
		  	LDP #0000h	
		 	ret
			nop
			nop
			nop		 	                                          

******************************************************************
*    8-   
* (   16     )
* 7F    (ACC   )
******************************************************************			
getword		
			call rio
			and #0FFh
			sacl 7Ch ;   
			call rio
			and #0FFh
			sacl  7Fh
			lacc 7Fh, 8 ;   
			or 7Ch
			sacl 7Fh
			ret
			nop
			nop
			nop

******************************************************************
*    I/O  ACC
* 7E     I/O
* 7F     I/O 
******************************************************************			
rio
			; 7E -   I/O
			lacc #11B1h ;  IN  ACC
			tblw 7Eh ;    I/O           
            b 11B0h
            nop
            nop
            nop
next		
            lacl 7Eh ;  
            add #1
            sacl 7Eh			
			lacl 7Fh ;     ACC
			ret
			nop
			nop
			nop
			.end			


